=== proc/Makefile ===
--- 
+++ 
@@ -4,6 +4,9 @@
 
 # PROJECT SPECIFIC MACROS
 NAME       =  proc
+#VERSION    =  1        #These are inherited 
+#SUBVERSION =  02
+#SHARED     =  #1#	if 1 then do shared libraries as well as static
 
 # INSTALLATION OPTIONS
 TOPDIR     = /usr
@@ -15,8 +18,8 @@
 INSTALL    = install
 
 # COMPILATION OPTIONS
-CC         =  gcc -O2 -D_GNU_SOURCE #-ggdb # easy to command-line override
-CFLAGS     =  -I.. -Wall
+CC         =  gcc -O4 -fomit-frame-pointer#-ggdb # easy to command-line override
+CFLAGS     =  -I.. -Wall -fwritable-strings $(PROC_COLOR)
 
 # ----------------------------------------------------------------#
 # The rest is the auto-magic section -- highly GNU make dependent #
@@ -35,10 +38,10 @@
 HDR        =  $(sort $(wildcard *.h) $(filter %.h,$(RCSFILES)))
 
 OBJ        =  $(SRC:.c=.o)
-SONAME     =  lib$(NAME).so.$(LIBVERSION)
+SOBJ       =  $(SRC:.c=.so)
+SONAME     =  lib$(NAME).so.$(VERSION).$(SUBVERSION)
 
 ifeq ($(SHARED),1)
-CFLAGS += -fpic
 all: lib$(NAME).a $(SONAME)
 else
 all: lib$(NAME).a
@@ -47,8 +50,8 @@
 lib$(NAME).a: $(OBJ)
 	$(AR) rcs $@ $^
 
-$(SONAME): $(OBJ)
-	gcc -Wl,-shared -Wl,-soname,$(SONAME) -o $@ $^ -lc
+$(SONAME): $(SOBJ)
+	gcc -Wl,-shared -Wl,-soname,$(SONAME) -o $@ $^
 	ln -sf $(SONAME) lib$(NAME).so
 
 # AUTOMATIC DEPENDENCY GENERATION -- GCC AND GNUMAKE DEPENDENT
@@ -75,7 +78,7 @@
 dep:	.depend
 
 clean:
-	$(RM) lib$(NAME).* *.o
+	$(RM) lib$(NAME).a lib$(NAME).so* *.o *.so
 
 distclean:	clean
 	$(RM) .depend signames.h
@@ -91,17 +94,19 @@
 %.o : %.c
 	$(strip $(CC) $(CFLAGS) -c $<)
 
+%.so : %.c
+	$(strip $(CC) $(CFLAGS) -fPIC -c $< -o $@)
+
 # PROJECT SPECIFIC DEPENDENCIES/BUILD RULES
 
 
 version.o:	version.c version.h
-ifdef MINORVERSION
-	$(strip $(CC) $(CFLAGS) -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -DMINORVERSION=\"$(MINORVERSION)\" -c version.c)
-else
 	$(strip $(CC) $(CFLAGS) -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -c version.c)
-endif
 
-signals.o : signames.h
+version.so:	version.c version.h
+	$(strip $(CC) $(CFLAGS) -fPIC -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -c version.c -o $@ )
+
+signals.o signals.so: signames.h
 
 signames.h ../proc/signames.h : /usr/include/signal.h
 	/lib/cpp -dM </usr/include/signal.h |	\
