=== debian/changelog ===
procps (1.11.1) unstable; urgency=low

  * fixed bug in w <username>
  * automatic resize if field length is exceeded. This changed the shared
    library, so popping the major number.
  * fixed numeric WCHAN output on Alphas and stupid bug in ps (again,
    thanks to H. Koenig). 
  * fixed top memory statistics for systems with more than 100M memory or 
    swap. 
  
 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Tue, 12 Nov 1996 02:57:18 +0100

procps (1.10.1) unstable; urgency=low

  * merged in ALPHA & Sparc patches
    (from ftp.azstarnet.com:/pub/linux/axp/glibc)
  * fixed ps --deselect/-N for pid lists    
  * use shared libs from now on, install shlibs again
  * manpages for libproc
  * static lib compiled without -fPIC
  * added libproc package for development installing libproc headers,
    manpages and static library. 
  * fixed PROC_REAL bug when PROC_FILLSTATUS isn't set.
  * fixed color bug in ps --forest
  * added xproc package for xload, xmem, xidle, xcpustate
    (XConsole left out as we use xconsole & klogd on debian)
  * adapted xload manpage for xidle and xmem
  * fixed xmem to cope with newer kernels (where shared pages are counted
    once for each additional reference)
  * fixed top change_fields bug (a field needs 24, not 21 spaces)
  * fixed several Alpha bugs (thanks to Harald Koenig)
  * due to popular demand, the old format for time intervals is back.
    for all program using this, a toggle command line option has been
    provided. The default behaviour depends on the compile time option
    NEW_TIME_DEFAULT (see main Makefile)

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Wed, 23 Oct 1996 21:30:54 +0200

procps (1.09.2) unstable; urgency=low

  * fixed cpu nice % in summary
  * fixed topsetup initialisation in top.h I messed up in last revision
  * fixed pipe output bug
  * fixed --deselect bug in SVR4/POSIX mode

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Sun, 20 Oct 1996 13:57:11 +0200

procps (1.09.1) unstable; urgency=low

  * fixed ps -w bug displaying too many empty lines
  * fixed SIGSEGV bug in ps -www
  * fixed bug in top not calculating length of the command/args/env fields
    at the field selection screen in some circumstances.
  * fixed SIGSEGV bug when using environ field

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Sat, 12 Oct 1996 07:59:29 +0200

procps (1.09) experimental; urgency=low

  * This is an experimental release of the procps suite. A lot of features have
    been added since the 1.01(a) release:
     - support for both BSD and POSIX (SVR4) style command line options.
     - completely configurable display of information.
     - colour markup of processes exceeding limits or belonging to a user.
    Please take a look at /usr/doc/procps/NEWS and the manpages for a concise
    list. This is how the next upstream release of procps may look
    (i.e. it will  look like this if there is not too much resistance).  

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Sat, 5 Oct 1996 14:26:57 +0200

Local Variables:
mode: debian-changelog
End:
